function GuBlit(bx, by, bz, img, xrot, yrot, zrot, size) -- special blit function using the GU
	--[[ 
	bx, by, bz = x, y, and z coordinates to draw the image at
	img = image to use
	xrot,  yrot, zrot = rotation in degrees for each axis
	size = size to display image in %, will default to 100% if left blank
	]]
	local w = img:width()/2
	local h = img:height()/2
	
	xrot = xrot * (Gu.PI/180)
	yrot = yrot * (Gu.PI/180)
	zrot = zrot * (Gu.PI/180)
	
	
	if size == nil then size = 1 else size = size / 100 end
	
	local imagetile = {
		-- top section
		{ .5,  .5,   0,   0,  0},
		{  0,   0,  -w*size,   h*size,  0},
		{  1,   0,   w*size,   h*size,  0},
		-- right section
		{0.5, 0.5,   0,   0,  0},
		{  1,   0,   w*size,   h*size,  0},
		{  1,   1,   w*size,  -h*size,  0},
		-- bottom section
		{0.5, 0.5,   0,   0,  0},
		{  1,   1,   w*size,  -h*size,  0},
		{  0,   1,  -w*size,  -h*size,  0},
		-- left section
		{0.5, 0.5,   0,   0,  0},
		{  0,   1,  -w*size,  -h*size,  0},
		{  0,   0,  -w*size,   h*size,  0},   
		}
	
	
	Gu.enable(Gu.TEXTURE_2D);
	Gu.texImage(img)
	Gu.texFunc(Gu.TFX_MODULATE, Gu.TCC_RGBA)
	Gu.texFilter(Gu.NEAREST, Gu.NEAREST)
	Gu.texScale(1, 1)
	Gu.texOffset(0, 0)
	Gum.matrixMode(Gu.MODEL)
	Gum.loadIdentity()
	Gum.translate(bx, by, bz);
	Gum.rotateXYZ(xrot, yrot, zrot)
	Gum.drawArray(Gu.TRIANGLES, Gu.TEXTURE_32BITF+Gu.VERTEX_32BITF+Gu.TRANSFORM_3D, imagetile)
end

function start_gu(fov) -- starts the gu for drawing with the GuBlit function, 
--if you dont put anything in the () when calling this function the fov will default to 50

	if fov == nil then fov = 50 end
	Gu.start3d()
	Gu.clearDepth(0);
	Gu.clear(Gu.COLOR_BUFFER_BIT+Gu.DEPTH_BUFFER_BIT)
	Gum.matrixMode(Gu.PROJECTION)
	Gum.loadIdentity()
	Gum.perspective(fov, 480/272, 0.5, 1000)
	Gum.matrixMode(Gu.VIEW)
	Gum.loadIdentity()
	Gum.matrixMode(Gu.MODEL)
	Gum.loadIdentity()
	Gu.enable(Gu.BLEND)
	Gu.blendFunc(Gu.ADD, Gu.SRC_ALPHA, Gu.ONE_MINUS_SRC_ALPHA, 0, 0)
end

function diagRectangle(x,y,width,height,angle,colour)
	local halfWidth = width/2
	local halfHeight = height/2

	triangles = {
		{colour,-halfWidth,-halfHeight,0},
		{colour,-halfWidth,halfHeight,0},
		{colour,halfWidth,-halfHeight,0},

		{colour,-halfWidth,halfHeight,0},
		{colour,halfWidth,halfHeight,0},
		{colour,halfWidth,-halfHeight,0}
	}

	Gum.matrixMode(Gu.MODEL)
	Gum.loadIdentity()
	Gum.translate(x, y, -294);
	Gu.disable(Gu.TEXTURE_2D)
	Gum.rotateXYZ(0, 0, math.rad(angle) )
	Gum.drawArray(Gu.TRIANGLES, Gu.COLOR_8888+Gu.VERTEX_32BITF+Gu.TRANSFORM_3D, triangles)
end
